#include<gsl/gsl_matrix.h>
#include <gsl/gsl_permutation.h>
#include <gsl/gsl_rng.h>
#include <gsl/gsl_randist.h>
#include <gsl/gsl_blas.h>
#include <gsl/gsl_cblas.h>
#include <gsl/gsl_statistics_float.h> 
#include<cassert>
#include<ctime>
#include<vector>
#include <unistd.h>
#include <cstring>
#include<algorithm>
#include<cmath>
#include<stdio.h>
#include<wfdb/wfdb.h>
//#include "../bib/auxfunctions.h"

using namespace std;

void movingaveragefilter(const float*inputsignal, float*outputsignal,
			 int filterL, int inputsignalL);
//../beatdetector_bp/movingaveragefiltercentered.cpp



void meansandvariances(const float*signal,float*means, float*variances,
		       int numsamplesintervals,int numintervals, int step){

  float aux;

  for(int i=0;i<numintervals;++i){
    float &mean=means[i];
    float &square=variances[i];
    mean=0;
    square=0;
    for(int j=0;j<numsamplesintervals;++j){

      aux=signal[i*step+j];
      mean+=aux;
      aux*=aux;
      square+=aux;
    }
    mean/=numsamplesintervals;
    square-=mean*mean;
    square/=numsamplesintervals+1;
  }

}


void powersignalintervals(const float*signal, float*powersignal,
			  int numsamplesintervals,int numintervals, int step){

  float aux;

  for(int i=0;i<numintervals;++i){

    powersignal[i]=0;

    for(int j=0;j<numsamplesintervals;++j)
      powersignal[i]+=signal[i*step+j]*signal[i*step+j];

    powersignal[i]/=numsamplesintervals;
  }
}



int main(int argc,char**argv){


  //argv[1] txt floats recpath (ex:/data/mgh/mgh001.txt)
  //argv[2]=sampling frequency
  //argv[3]=numsecs interval ->(10)
  //argv[4]=numsamples signal


  if(argc<5){
    printf("usage: signal-txt-filename samplingfreq numsecsinterval numsamples\n");
    exit(-1);
  }

  int samplingfreq=atoi(argv[2]);
  int numsecs=atoi(argv[3]);
  int numsamples=atoi(argv[4]);

  float* signal=new float[numsamples];
  FILE*fid=fopen(argv[1],"r");
  for(int i=0;i<numsamples;++i)
    fscanf(fid,"%f",signal+i);
  fclose(fid);

  int numsamplesinterval=numsecs*samplingfreq;
  int step=numsecs*samplingfreq/2;
  int numintervals=(numsamples-numsamplesinterval)/step+1;


  // no baseline is ecg with (approximately) baseline removed and
  // reversed signal 
  float*nobaseline=new float[numsamples];
  movingaveragefilter(signal, nobaseline,samplingfreq,
		      numsamples);//one second length
  for(int i=0;i<numsamples;++i)
    nobaseline[i]-=signal[i];


  float*powersignalnobase=new float[numintervals];
  powersignalintervals(nobaseline, powersignalnobase,
		       numsamplesinterval, numintervals, step);

  //DEBUG
  //fid=fopen("filteredsignal



  //save powersignalnobase on a file
  char fnameflat[]="powersignalnobase.txt";
  fid=fopen(fnameflat,"w");
  for(int i=0;i<numintervals;++i)
    fprintf(fid,"%f \n", powersignalnobase[i]);
  fclose(fid);

  delete[] signal;
  delete[] nobaseline;
  delete[] powersignalnobase;

  return 0;
}
