#include<gsl/gsl_matrix.h>
#include <gsl/gsl_permutation.h>
#include <gsl/gsl_rng.h>
#include <gsl/gsl_randist.h>
#include <gsl/gsl_blas.h>
#include <gsl/gsl_cblas.h>
#include<cassert>
#include<ctime>
#include <unistd.h>
#include <cstring>
#include<algorithm>
#include<cmath>
#include <sys/time.h>  
 #include <stdio.h>  
#include <wfdb/wfdb.h>
#include<vector>
using namespace std;

void findlocmax(gsl_vector_float*signal,vector<int>&locmax,float threshold,
		int radius){

  int numelements=signal->size;

  float*sigaux=new float[numelements];

  memcpy((void*) sigaux, (void*) signal->data, numelements*(sizeof(float)));

  for(int i=0;i<numelements;++i)
    if(sigaux[i]<threshold)
      sigaux[i]=0.0;


  //begining of signal (before radius+1 elements)
  for(int i=0;i<radius;++i)
    if(sigaux[i]>0)
      if(sigaux+i==max_element(sigaux,sigaux+i+radius))
	locmax.insert(locmax.end(),i);

  //all but begining and ending of sigaux
  for(int i=radius;i<numelements-radius;++i)
    if(sigaux[i]>0)
      if(sigaux+i==max_element(sigaux+i-radius,sigaux+i+radius))
	locmax.insert(locmax.end(),i);

  //end of sigaux
  for(int i=numelements-radius;i<numelements;++i)
    if(sigaux[i]>0)
      if(sigaux+i==max_element(sigaux+i-radius,sigaux+i+radius))
	locmax.insert(locmax.end(),i);
    
  delete[] sigaux;
}






