#include<vector>
using namespace std;


//given quality indices of signals and thresholds, select for each interval
//the signal from which detections are taken

int anygoodecg(vector<float>&egspower, vector<float>&egscomparedetections,
	       float ecgspowerlimit,float ecgscomparedetectionslimit, int numecgs);

int anygoodbp(vector<float>&bpspower, float bpspowerlimit,int numbps);

void selectsignalsonintervals(vector<int>&ecgsignals,vector<int>&bpsignals,
			      vector<vector<float> >&ecgspower,
			      vector<vector<float> >&ecgscomparedetections,
			      vector<vector<float> >&bpspower,
			      vector<vector<float> >&bpscomparedetections,
			      vector<int>&signalonintervals,
			      float ecgspowerlimit,float ecgscomparedetectionslimit,
			      float bpspowerlimit,float bpscomparedetectionslimit){

  //result is on signalonintervals

  int numecgs=ecgsignals.size();
  int numbps=bpsignals.size();

  //------------------numintervals----------------------
  int numintervals;
  if(numecgs>0)
    numintervals=ecgspower[0].size();
  //in case of some error(..)
  for(int i=0;i<numecgs;++i){
    if(numintervals>ecgspower[i].size() )
      numintervals=ecgspower[i].size();
    if(numintervals>ecgscomparedetections[i].size() )
      numintervals=ecgscomparedetections[i].size();
  }
  for(int i=0;i<numbps;++i){
    if(numintervals>bpspower[i].size() )
      numintervals=bpspower[i].size();
    // if(numintervals>bpscomparedetections[i].size() )
    //   numintervals=bpscomparedetections[i].size();
 }
 //----------------------------------------------------


  signalonintervals.resize(numintervals);
 //signalonintervals[j]=-1 if interval is not assigned, otherwise=sig assigned
 int intervaldecided[numintervals];
 for(int j=0;j<numintervals;++j)
   signalonintervals[j]=-1;

 int sig;
 
 vector<float> ecgpowervalues;
 vector<float> ecgcomparedetections;
 if(numecgs>0){
   ecgpowervalues.resize(numecgs);
   ecgcomparedetections.resize(numecgs);
 }
 vector<float> bppowervalues;
 if(numbps>0)
   bppowervalues.resize(numbps);

 for(int j=0; j<numintervals;++j){

   if(numecgs>0){
     for(int i=0;i<numecgs;++i){
       ecgpowervalues[i]=ecgspower[i][j];
       ecgcomparedetections[i]=ecgscomparedetections[i][j];
     } 
     signalonintervals[j]=anygoodecg(ecgpowervalues,ecgcomparedetections,
				     ecgspowerlimit, ecgscomparedetectionslimit, numecgs);
     if(signalonintervals[j]!=-1)
       signalonintervals[j]=ecgsignals[signalonintervals[j] ];
   }

   if((signalonintervals[j]<0)&&(numbps>0)){
     for(int i=0;i<numbps;++i)
       bppowervalues[i]=bpspower[i][j];
     signalonintervals[j]=anygoodbp(bppowervalues,bpspowerlimit,numbps);
     if(signalonintervals[j]!=-1)
       signalonintervals[j]=bpsignals[signalonintervals[j] ];
   } 
 }
}


int anygoodecg(vector<float>&egspower, vector<float>&egscomparedetections,
	       float ecgspowerlimit,float ecgscomparedetectionslimit, int numecgs){

  for(int i=0;i<numecgs;++i)
    if((egspower[i]>ecgspowerlimit)&&(egscomparedetections[i]>ecgscomparedetectionslimit))
      return i;

  return -1;
}

int anygoodbp(vector<float>&bpspower, float bpspowerlimit,int numbps){

  for(int i=0;i<numbps;++i)
    if(bpspower[i]>bpspowerlimit)
      return i;

  return -1;
}
