#include<gsl/gsl_matrix.h>
#include <gsl/gsl_permutation.h>
#include <gsl/gsl_rng.h>
#include <gsl/gsl_randist.h>
#include <gsl/gsl_blas.h>
#include <gsl/gsl_cblas.h>
#include <gsl/gsl_statistics_float.h> 
#include<cassert>
#include<ctime>
#include<vector>
#include <unistd.h>
#include <cstring>
#include<algorithm>
#include<cmath>
#include<stdio.h>
#include<wfdb/wfdb.h>
//#include "../bib/auxfunctions.h"

using namespace std;


//int insertrecordallnoannot(char*recpath, int samplingfreq,
//			   char*signaltype, vector<float>&longsignal);

using namespace std;

//write  signal to txt file ./(rec.txt) using physical units value
// (floats)

int main(int argc, char** argv){

  // argv[1] is recordpath
  //argv [2] is the signal number (starts at 0)
  //argv[3] is recname

  int signalnumber=atoi(argv[2]);

  WFDB_Siginfo *s;
  int i, nsig;
  WFDB_Time t0, t1;




  //char fname[200];
  //strcpy(fname,argv[3]);
  //strcat(fname,argv[1]);

  vector<float> signal;

  nsig = isigopen(argv[1], NULL, 0);
  if (nsig < 1) exit(2);
  s = (WFDB_Siginfo *)malloc(nsig * sizeof(WFDB_Siginfo));
  if (s == NULL) {
    fprintf(stderr, "insufficient memory\n");
    exit(3);
  }
  WFDB_Sample *v=new WFDB_Sample[nsig];


  if (isigopen(argv[1], s, nsig) != nsig) exit(2);
  printf("Record %s\n", argv[1]);
  printf("Starting time: %s\n", timstr(0L));
  printf("Sampling frequency: %g Hz\n", sampfreq(argv[1]));

  assert(signalnumber<nsig);
  /*assert(strcmp("ECG",s[i].desc)<=0);*/

   printf(" Description: %s\n", s[signalnumber].desc);

   if (s[signalnumber].nsamp > 0L) {
     printf(" Length: %s (%ld sample intervals)\n",
	    timstr(s[signalnumber].nsamp), s[signalnumber].nsamp);

     t1= s[signalnumber].nsamp;
     t0=0;

     for (int t = t0; t <= t1; t++) {    
       if(getvec(v)<0)
	 break;
       signal.push_back(aduphys(signalnumber,v[signalnumber]));	 
     }

     char sigfname[20];
     strcpy(sigfname,argv[3]);
     strcat(sigfname,".txt");
     FILE*fid=fopen(sigfname,"w");

     for(int t=t0;t<t1;++t)
       fprintf(fid,"%f\n",signal[t]);
     fclose(fid);
   }
   else printf(" Length undefined\n");
 
  
return 0;
}
